import * as t from 'io-ts';
import * as Region_ad49_ from '../../core/region';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/maas-backend/customers/personalDataCatalog.json";
export type RegionRestriction = t.Branded<Array<Region_ad49_.RegionId>, RegionRestrictionBrand>;
export type RegionRestrictionC = t.BrandC<t.ArrayC<typeof Region_ad49_.RegionId>, RegionRestrictionBrand>;
export declare const RegionRestriction: RegionRestrictionC;
export type RegionRestrictionBrand = {
    readonly RegionRestriction: unique symbol;
};
export type DependsOnRestriction = t.Branded<({
    name?: string;
    values?: Array<string>;
} & Record<string, unknown>) & {
    name: Defined;
}, DependsOnRestrictionBrand>;
export type DependsOnRestrictionC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            name: t.StringC;
            values: t.ArrayC<t.StringC>;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        name: typeof Defined;
    }>
]>, DependsOnRestrictionBrand>;
export declare const DependsOnRestriction: DependsOnRestrictionC;
export type DependsOnRestrictionBrand = {
    readonly DependsOnRestriction: unique symbol;
};
export type PersonalDataCatalogItem = t.Branded<{
    name?: string;
    type?: string & ('string' | 'ISODate' | 'ISODatetime' | 'ISOCountryAlpha2');
    enum?: Array<string>;
    canShowPlain?: boolean;
    regionRestriction?: RegionRestriction;
    dependsOn?: Array<DependsOnRestriction>;
} & {
    name: Defined;
    type: Defined;
    canShowPlain: Defined;
}, PersonalDataCatalogItemBrand>;
export type PersonalDataCatalogItemC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        name: t.StringC;
        type: t.IntersectionC<[
            t.StringC,
            t.UnionC<[
                t.LiteralC<'string'>,
                t.LiteralC<'ISODate'>,
                t.LiteralC<'ISODatetime'>,
                t.LiteralC<'ISOCountryAlpha2'>
            ]>
        ]>;
        enum: t.ArrayC<t.StringC>;
        canShowPlain: t.BooleanC;
        regionRestriction: typeof RegionRestriction;
        dependsOn: t.ArrayC<typeof DependsOnRestriction>;
    }>,
    t.TypeC<{
        name: typeof Defined;
        type: typeof Defined;
        canShowPlain: typeof Defined;
    }>
]>, PersonalDataCatalogItemBrand>;
export declare const PersonalDataCatalogItem: PersonalDataCatalogItemC;
export type PersonalDataCatalogItemBrand = {
    readonly PersonalDataCatalogItem: unique symbol;
};
export type PersonalDataCatalog = t.Branded<unknown, PersonalDataCatalogBrand>;
export type PersonalDataCatalogC = t.BrandC<t.UnknownC, PersonalDataCatalogBrand>;
export declare const PersonalDataCatalog: PersonalDataCatalogC;
export type PersonalDataCatalogBrand = {
    readonly PersonalDataCatalog: unique symbol;
};
export default PersonalDataCatalog;
